/*  
 *
 * Copyright (C) 2000 Panagiotis Issaris <takis@lumumba.luc.ac.be> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * $Author: takis $
 * $Date: 2000/11/07 11:09:39 $
 * $Revision: 1.1 $
 *
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <math.h>

typedef void (*frame_convertor) (GdkPixbuf *);
typedef unsigned char (*byte_convertor) (unsigned char);
typedef unsigned char (*byte_convertor2) (unsigned char, unsigned char);
typedef unsigned char (*byte_convertor3) (unsigned char, unsigned char,
					  unsigned char);

void gdk_pixbuf_putpix (GdkPixbuf * pb, int x, int y);
void gdk_pixbuf_op (GdkPixbuf * pb, byte_convertor red, byte_convertor green,
		    byte_convertor blue);
void gdk_pixbuf_op1 (GdkPixbuf * pb, byte_convertor component);
unsigned char gdk_pixbuf_color_component_op_invert (unsigned char c);
void gdk_pixbuf_invert (GdkPixbuf * pb);
unsigned char gdk_pixbuf_color_component_op_keep (unsigned char p);
unsigned char gdk_pixbuf_color_component_op_zero (unsigned char p);
void gdk_pixbuf_red (GdkPixbuf * pb);
void gdk_pixbuf_green (GdkPixbuf * pb);
void gdk_pixbuf_blue (GdkPixbuf * pb);
void gdk_pixbuf_grayscale (GdkPixbuf * pb);
void gdk_pixbuf_emboss2 (GdkPixbuf * src, GdkPixbuf ** dst);
void gdk_pixbuf_emboss (GdkPixbuf * pb);
void gdk_pixbuf_blur (GdkPixbuf * pb);
void gdk_pixbuf_blurm (GdkPixbuf * pb);
void gdk_pixbuf_edge_detect (GdkPixbuf * pb);
void gdk_pixbuf_sharpen (GdkPixbuf * pb);
void gdk_pixbuf_value_color (GdkPixbuf * src1, GdkPixbuf * src2,
			     GdkPixbuf ** dst);
void gdk_pixbuf_blend (GdkPixbuf * src1, GdkPixbuf * src2, GdkPixbuf ** dst,
		       unsigned char a);
unsigned char mul_pixel (unsigned char a, unsigned char b);
unsigned char div_pixel (unsigned char a, unsigned char b);
unsigned char sub_pixel (unsigned char a, unsigned char b);
unsigned char add_pixel (unsigned char a, unsigned char b);
void gdk_pixbuf_add (GdkPixbuf * src1, GdkPixbuf * src2, GdkPixbuf ** dst);
void gdk_pixbuf_sub (GdkPixbuf * src1, GdkPixbuf * src2, GdkPixbuf ** dst);
void gdk_pixbuf_mul (GdkPixbuf * src1, GdkPixbuf * src2, GdkPixbuf ** dst);
void gdk_pixbuf_div (GdkPixbuf * src1, GdkPixbuf * src2, GdkPixbuf ** dst);
